/***************************************************************************
 *   Copyright (C) 2005 by Alexander Saal                                  *
 *   alex.saal@gmx.de                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "vsprogen.h"

#include <QtGui/QFileDialog>
#include <QtGui/QApplication>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QPushButton>
#include <QtGui/QRadioButton>
#include <QtGui/QDesktopWidget>

#include <QtCore/QProcess>
#include <QtCore/QByteArray>
#include <QtCore/QStringList>
#include <QtCore/QFile>
#include <QtCore/QDir>
#include <QtCore/QRect>


vsprogen::vsprogen(QWidget *parent)
    : QWidget(parent)
{
	ui.setupUi(this);
    
	QDesktopWidget *desktop = qApp->desktop();
    const QRect rect = desktop->availableGeometry( desktop->primaryScreen() );
    int left = ( rect.width() - width() ) / 2;
    int top = ( rect.height() - height() ) / 2;
    setGeometry( left, top, width(), height() );
}

vsprogen::~vsprogen()
{

}

void vsprogen::on_btnChoose_Qt4ProFile_clicked()
{
    QString fileName = QFileDialog::getOpenFileName( this, "Choose Qt4 Projectfile", QDir::currentPath(), "Qt4 Projectfile (*.pri)");
	ui.lineEditQt_ProFile->setText(fileName);	
}

void vsprogen::on_btnSave_VSFile_clicked()
{
	QString dspSafe = QFileDialog::getSaveFileName( this, "Save Visual Studio 6 /Dev C++ Projectfile", QDir::currentPath(), "VS 6 / Dev C++ file (*.dsp)");
	ui.lineEditVs_ProFile->setText(dspSafe + ".dsp");
}

void vsprogen::on_btnSave_VSNetFile_clicked()
{
	QString vspro = QFileDialog::getSaveFileName( this, "Save Visual Studio .Net Projectfile", QDir::currentPath(), "VS 6 / Dev C++ file (*.vcproj)");
	ui.lineEditVsNet_ProFile->setText(vspro + ".vcproj");
}

void vsprogen::on_btnCreate_VS_clicked()
{
	/*ein neuen QProcess erzeugen*/
	QProcess *procCreateVs = new QProcess( this );           /*Process fr Visual Studio*/
     QStringList proFileVs;            /*StringList fr Visual Studio*/

     /*der QStringList die parameter bergeben die wir brauchen um die datei zu erzeugen*/
     proFileVs.append( "-spec" );                         
     proFileVs.append( "win32-msvc" );
     proFileVs.append( "-t" );
     proFileVs.append( "vcapp" );
     proFileVs.append( "-o" );
     proFileVs.append( ui.lineEditVs_ProFile->text() );
     proFileVs.append( ui.lineEditQt_ProFile->text() );
     
     
     /*den QProcess starteb*/
     procCreateVs->start( "qmake",proFileVs );          
     
     /*dem QProcess eine SIGNAL und ein SLOT zuweisen, siehe dazu etwas weiter unten*/

	 if (procCreateVs->waitForFinished()){
         ui.lblInfo->setText( "File [ " + ui.lineEditVs_ProFile->text() + " ] created" );
	 }else{
		 ui.lblInfo->setText( "File [ " + ui.lineEditVs_ProFile->text() + " ] not created" );
	 }
     
     /*die QStringList wieder leeren, sonst knnten probleme auftauchen*/
     proFileVs.clear();
}

void vsprogen::on_btnCreate_VSNet_clicked()
{

	QProcess *procCreateVsNet = new QProcess( this );        /*Process fr Visual Studio .Net*/     
	QStringList proFileVsNet;         /*StringListVisual Studio .Net*/

     proFileVsNet.append( "qmake" );
     proFileVsNet.append( "-spec" );
     proFileVsNet.append( "win32-msvc.net" );
     proFileVsNet.append( "-t" );
     proFileVsNet.append( "vcapp" );
     proFileVsNet.append( "-o" );
     proFileVsNet.append( ui.lineEditVsNet_ProFile->text() );
     proFileVsNet.append( ui.lineEditQt_ProFile->text() );

	 procCreateVsNet->start( "qmake", proFileVsNet );
     
	 if (procCreateVsNet->waitForFinished()){
			 ui.lblInfo->setText( "File [ " + ui.lineEditVsNet_ProFile->text() + " ] created" );
	 }else{
			 ui.lblInfo->setText( "File [ " + ui.lineEditVsNet_ProFile->text() + " ] not created" );
	 }		 
         
     proFileVsNet.clear();
}